//+------------------------------------------------------------------+
//|                                              .mq4 |
//|                               Copyright  2011,   |
//|                                                cmillion@narod.ru |
//+------------------------------------------------------------------+
#property copyright "cmillion@narod.ru"
#property link      "cmillion@narod.ru"
//--------------------------------------------------------------------
extern string  MA1="";     
//----    ---------"JJMA" ,Length ,Phase,Shift,Input_Price_Customs -----------------------------------------+
extern int Length1 = 5;   //  JMA  
extern int Phase1  = 100; //  JMA ,    -100 ... +100,     ; 
extern int Shift1  = 0;   // c     
extern int Input_Price_Customs1 = 0;/*  ,      
(0-CLOSE, 1-OPEN, 2-HIGH, 3-LOW, 4-MEDIAN, 5-TYPICAL, 6-WEIGHTED, 7-Heiken Ashi Close, 8-SIMPL, 9-TRENDFOLLOW, 10-0.5*TRENDFOLLOW,
11-Heiken Ashi Low, 12-Heiken Ashi High,  13-Heiken Ashi Open, 14-Heiken Ashi Close.) */
//---- -------------------------------------------------------------------------------------------------------------------------------+
extern int              timeframe_1          = 0;           //.      . 0    .
extern string  MA2="";     
//----    ---------"JJMA" ,Length ,Phase,Shift,Input_Price_Customs -----------------------------------------+
extern int Length2 = 12;   //  JMA  
extern int Phase2  = 100; //  JMA ,    -100 ... +100,     ; 
extern int Shift2  = 0;   // c     
extern int Input_Price_Customs2 = 0;/*  ,      
(0-CLOSE, 1-OPEN, 2-HIGH, 3-LOW, 4-MEDIAN, 5-TYPICAL, 6-WEIGHTED, 7-Heiken Ashi Close, 8-SIMPL, 9-TRENDFOLLOW, 10-0.5*TRENDFOLLOW,
11-Heiken Ashi Low, 12-Heiken Ashi High,  13-Heiken Ashi Open, 14-Heiken Ashi Close.) */
//---- -------------------------------------------------------------------------------------------------------------------------------+
 extern int              timeframe_2          = 0;           //.      . 0    .
extern string  MA3="";     
//----    ---------"JJMA" ,Length ,Phase,Shift,Input_Price_Customs -----------------------------------------+
extern int Length3 = 36;   //  JMA  
extern int Phase3  = 100; //  JMA ,    -100 ... +100,     ; 
extern int Shift3  = 0;   // c     
extern int Input_Price_Customs3 = 0;/*  ,      
(0-CLOSE, 1-OPEN, 2-HIGH, 3-LOW, 4-MEDIAN, 5-TYPICAL, 6-WEIGHTED, 7-Heiken Ashi Close, 8-SIMPL, 9-TRENDFOLLOW, 10-0.5*TRENDFOLLOW,
11-Heiken Ashi Low, 12-Heiken Ashi High,  13-Heiken Ashi Open, 14-Heiken Ashi Close.) */
//---- -------------------------------------------------------------------------------------------------------------------------------+
extern int           timeframe_3          = 0;           //.      . 0    .
extern string  _="";     
extern double     stoploss             = 10.0;           //
extern double     takeprofitB           = 10.0;           //
extern double     takeprofitS           = 10.0;           //
extern double     TrailingStop         = 10.0;           //,  0,   
extern double     NoLoss               = 0.0;           //  ,  0,     
extern int     MaxOrders            = 1;           // -    
extern double  LOT                  = 0.1;         // 
extern bool    CloseRevers          = true;        //    
extern int Magic=1234567890;
//--------------------------------------------------------------------
int TimeBar,STOPLEVEL;
//--------------------------------------------------------------------
int init() { 
if(Digits == 3 || Digits == 5)
     {
      stoploss   *= 10;
      takeprofitB   *= 10;
      takeprofitB   *= 10;
      TrailingStop *= 10;
      NoLoss *= 10;
     }
   return(0);
}
int deinit() { 
 return(0);
 }




int start()
{
   STOPLEVEL=MarketInfo(Symbol(),MODE_STOPLEVEL);
   if (TrailingStop>=STOPLEVEL) TrailingStop();
   if (NoLoss>=STOPLEVEL) NoLoss();
   if (TimeBar==Time[0]) return(0);//iCustom
   double MA10 = NormalizeDouble(iCustom(NULL,timeframe_1, "JJMA" ,Length1 ,Phase1,Shift1,Input_Price_Customs1,0),Digits);
   double MA11 = NormalizeDouble(iCustom(NULL,timeframe_1, "JJMA" ,Length1 ,Phase1,Shift1,Input_Price_Customs1,1),Digits);
   double MA20 = NormalizeDouble(iCustom(NULL,timeframe_2, "JJMA" ,Length2 ,Phase2,Shift2,Input_Price_Customs2,0),Digits);
   double MA21 = NormalizeDouble(iCustom(NULL,timeframe_2, "JJMA" ,Length2 ,Phase2,Shift2,Input_Price_Customs2,1),Digits);
   double MA3  = NormalizeDouble(iCustom(NULL,timeframe_3, "JJMA" ,Length3 ,Phase3,Shift3,Input_Price_Customs3,0),Digits);
   ObjectDelete("MA10");
   ObjectCreate("MA10",OBJ_ARROW,0,Time[0],MA10,0,0,0,0);                     
   ObjectSet   ("MA10",OBJPROP_ARROWCODE,6);
   ObjectSet   ("MA10",OBJPROP_COLOR, Blue); 
   ObjectDelete("MA20");
   ObjectCreate("MA20",OBJ_ARROW,0,Time[0],MA20,0,0,0,0);                     
   ObjectSet   ("MA20",OBJPROP_ARROWCODE,6);
   ObjectSet   ("MA20",OBJPROP_COLOR, Blue); 
   
   double SL,TPB,TPS;
   if (MA10>=MA20&&MA11<MA21&&MA20>=MA3)
   {
      if (CloseRevers) CLOSEORDER(OP_SELL);
      if (MaxOrders>OrdersTotal())       
      {
         if (takeprofitB) TPB  = NormalizeDouble(Ask + takeprofitB*Point,Digits) ;
         if (stoploss)   SL  = NormalizeDouble(Bid - stoploss*Point,Digits);
         if (OrderSend(Symbol(),OP_BUY, LOT,NormalizeDouble(Ask,Digits),2,SL,TPB," ",Magic,3)!=-1) TimeBar=Time[0]; 
         else Print("OrderSend BUY Error ",GetLastError(),"  SL ",SL,"  TP ",TPB);
      }
   }
   if (MA10<=MA20&&MA11>MA21&&MA20<=MA3)
   {
      if (CloseRevers) CLOSEORDER(OP_BUY);
      if (MaxOrders>OrdersTotal()) 
      {
         if (takeprofitS) TPS = NormalizeDouble(Bid - takeprofitS*Point,Digits);
         if (stoploss)   SL = NormalizeDouble(Ask + stoploss*Point,Digits);
         if (OrderSend(Symbol(),OP_SELL,LOT,NormalizeDouble(Bid,Digits),2,SL,TPS," ",Magic,3)!=-1) TimeBar=Time[0]; 
         
      }
   }
return(0);
}
//--------------------------------------------------------------------
void CLOSEORDER(int ord)
{
   for (int i=0; i<OrdersTotal(); i++)
   {                                               
      if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
      {
         if (OrderSymbol()==Symbol() && OrderMagicNumber()==Magic)
         {
            if (OrderType()==OP_BUY && ord==OP_BUY)
               OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Bid,Digits),3,CLR_NONE);
            if (OrderType()==OP_SELL && ord==OP_SELL)
               OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Ask,Digits),3,CLR_NONE);
         }
      }   
   }
}
//--------------------------------------------------------------------
void TrailingStop()
{
   int tip,Ticket;
   double StLo,OSL,OOP;
   for (int i=0; i<OrdersTotal(); i++) 
   {  if (OrderSelect(i, SELECT_BY_POS))
      {  tip = OrderType();
         if (tip<2 && OrderSymbol()==Symbol() && OrderMagicNumber()==Magic)
         {
            OSL   = NormalizeDouble(OrderStopLoss(),Digits);
            OOP   = NormalizeDouble(OrderOpenPrice(),Digits);
            Ticket = OrderTicket();
            if (tip==OP_BUY)             
            {
               StLo = NormalizeDouble(Bid-TrailingStop*Point,Digits);
               if (StLo > OSL && StLo > OOP)
               {  if (!OrderModify(Ticket,OOP,StLo,OrderTakeProfit(),0,White))
                     Print("TrailingStop Error ",GetLastError()," buy SL ",OSL,"->",StLo);
               }
            }                                         
            if (tip==OP_SELL)        
            {
               StLo = NormalizeDouble(Ask+TrailingStop*Point,Digits);
               if (StLo > OOP || StLo==0) continue;
               if (StLo < OSL || OSL==0 )
               {  if (!OrderModify(Ticket,OOP,StLo,OrderTakeProfit(),0,White))
                     Print("TrailingStop Error ",GetLastError()," sell SL ",OSL,"->",StLo);
               }
            } 
         }
      }
   }
}
//--------------------------------------------------------------------
void NoLoss()
{
   int tip,Ticket;
   double StLo,OSL,OOP;
   for (int i=0; i<OrdersTotal(); i++) 
   {  if (OrderSelect(i, SELECT_BY_POS))
      {  tip = OrderType();
         if (tip<2 && OrderSymbol()==Symbol() && OrderMagicNumber()==Magic)
         {
            OSL   = NormalizeDouble(OrderStopLoss(),Digits);
            OOP   = NormalizeDouble(OrderOpenPrice(),Digits);
            Ticket = OrderTicket();
            if (tip==OP_BUY)             
            {
               if (OSL>OOP) continue;
               StLo = NormalizeDouble(OOP+Point,Digits);
               if (NormalizeDouble((Bid-OOP)/Point,0)>=NoLoss)
               {  if (!OrderModify(Ticket,OOP,StLo,OrderTakeProfit(),0,White))
                     Print("NoLoss Error ",GetLastError()," buy SL ",OSL,"->",StLo);
               }
            }                                         
            if (tip==OP_SELL)        
            {
               if (OSL<OOP) continue;
               StLo = NormalizeDouble(OOP-Point,Digits);
               if (NormalizeDouble((OOP-Ask)/Point,0)>=NoLoss)
               {  if (!OrderModify(Ticket,OOP,StLo,OrderTakeProfit(),0,White))
                     Print("NoLoss Error ",GetLastError()," sell SL ",OSL,"->",StLo);
               }
            } 
         }
      }
   }
}
//--------------------------------------------------------------------

